/*----------------------------------------------------------*
   SH7145 ȈՃu[g[_ Ver. 1.33
                                       Last Edit '09 06/25
   Copyright (c) 2008 BestTechnology CO.,LTD.
 *----------------------------------------------------------*/

#include  <7145.h>
#include  <ctype.h>
#include  <stdbool.h>
#include  <stdlib.h>
#include  <string.h>

#define SCI SCI1

#if 1
#define _XMODEM_PACKET_SIZE 128
#else
#define _XMODEM_PACKET_SIZE 1024
#endif

#define RAM_ADDRESS     (0x00400000U)
#define RAM_LONG_SIZE   (262144)
#define RAM_BYTE_SIZE   (1048576U)
#define FLASH_ADDRESS   (0x00200000U)
#define FLASH_WORD_SIZE (1015808)         // SA0..SA30
#define FLASH_BYTE_SIZE (2031620)         // SA0..SA30
#define FLASH_SIG1      (0x000422C4U)
#define FLASH_SIG2      (0x000122C4U)

#define _SOH                0x01
#define _STX                0x02
#define _EOT                0x04
#define _ACK                0x06
#define _NAK                0x15
#define _CAN                0x18
#define _XYN                _NAK
#define _XYC                'C'
#define _XYG                'G'

typedef char *pchar;
#ifndef u8
typedef unsigned char u8;
#endif
#ifndef u16
typedef unsigned short u16;
#endif
#ifndef u32
typedef unsigned int u32;
#endif
#ifndef u64
typedef unsigned long long u64;
#endif

const char *mess[] = {
  // 0
  "\n--< TIM7145 Ver1.33 by BestTechnology >--",

  // 1
  "\n [w]:UPLOAD TO ExRAM [f]:UPLOAD TO ExFLASH\n"
  " [r]:DOWNLOAD [g]:BOOT [x]:REBOOT\n"
  " [i]:FLASH INFO [e]:ERASE ExFLASH [c]:CLEAR ExRAM",
  // 2
  "\n GO ExRAM PROGRAM !!\n",
  // 3
  "\n GO ExFLASH PROGRAM !!\n",
  // 4
  "\n START UPLOAD TO ExRAM...",
  // 5
  "\n START UPLOAD TO ExFLASH...",
  // 6
  "\n START DOWNLOAD...",
  // 7
  "\n <SUCCESS>",
  // 8
  "\n <ERROR>",
  // 9
  "\n CANCELED.",
  // 10
  "\n COMPLETED.",
  // 11
  "\n ARE YOU SURE? (Y/N) ",
  // 12
  "\n ERASE ALL ExFLASH",
  // 13
  "\n ERASE ALL ExRAM",
  // 14
  "\n EMPTY",
  // 15
  "\n START ADDRESS:$",
  // 16
  "\n SIZE:$",
  // 17
  "\nRESET BOOT BY WDT",
};

bool wait (long num, bool rx);

// ORAMgpDTCpxN^AhX` $00400`
const u16 DTCV[] __attribute__ ((section (".dtcvect"))) = {
  (u16)0xffffe000,  (u16)0xffffe010,  (u16)0xffffe020,  (u16)0xffffe030,
  (u16)0xffffe040,  (u16)0xffffe050,  (u16)0xffffe060,  (u16)0xffffe070,
  (u16)0xffffe080,  (u16)0xffffe090,  (u16)0xffffe0A0,  (u16)0xffffe0B0,
  (u16)0xffffe0C0,  (u16)0xffffe0D0,  (u16)0xffffe0E0,  (u16)0xffffe0F0,

  (u16)0xffffe100,  (u16)0xffffe110,  (u16)0xffffe120,  (u16)0xffffe130,
  (u16)0xffffe140,  (u16)0xffffe150,  (u16)0xffffe160,  (u16)0xffffe170,
  (u16)0xffffe180,  (u16)0xffffe190,  (u16)0xffffe1A0,  (u16)0xffffe1B0,
  (u16)0xffffe1C0,  (u16)0xffffe1D0,  (u16)0xffffe1E0,  (u16)0xffffe1F0,

  (u16)0xffffe200,  (u16)0xffffe210,  (u16)0xffffe220,  (u16)0xffffe230,
  (u16)0xffffe240,  (u16)0xffffe250,  (u16)0xffffe260,  (u16)0xffffe270,
  (u16)0xffffe280,  (u16)0xffffe290,  (u16)0xffffe2A0,  (u16)0xffffe2B0,
  (u16)0xffffe2C0,  (u16)0xffffe2D0,  (u16)0xffffe2E0,  (u16)0xffffe2F0,

  (u16)0xffffe300,  (u16)0xffffe310,  (u16)0xffffe320,  (u16)0xffffe330,
  (u16)0xffffe340,  (u16)0xffffe350,  (u16)0xffffe360,  (u16)0xffffe370,
  (u16)0xffffe380,  (u16)0xffffe390,  (u16)0xffffe3A0,  (u16)0xffffe3B0,
  (u16)0xffffe3C0,  (u16)0xffffe3D0,  (u16)0xffffe3E0,  (u16)0xffffe3F0,

  (u16)0xffffe400,  (u16)0xffffe410,  (u16)0xffffe420,  (u16)0xffffe430,
  (u16)0xffffe440,  (u16)0xffffe450,  (u16)0xffffe460,  (u16)0xffffe470,
  (u16)0xffffe480,  (u16)0xffffe490,  (u16)0xffffe4A0,  (u16)0xffffe4B0,
  (u16)0xffffe4C0,  (u16)0xffffe4D0,  (u16)0xffffe4E0,  (u16)0xffffe4F0
};

/*======================================================================*/
/* SCI                                                                  */
/*======================================================================*/
// RX FLAG
short rs_rx_buff (void) {
  return ((SCI.SSR.BYTE & 0x78) != 0) ;
}

// CHR OUT
void rs_putc (char c) {
  while (SCI.SSR.BIT.TDRE == 0) ;
  SCI.TDR = c;
  SCI.SSR.BIT.TDRE = 0;
}

void rs_repeatchar (char c, int num) {
  for (;num > 0; num--) rs_putc (c);
}
// STR IN
void rs_puts (char *s) {
  while (*s) rs_putc (*s++);
}

// CHR IN
u8 rs_getc (void) {
  char c;

  do {
   SCI.SSR.BYTE &= ~0x38;
  } while (!SCI.SSR.BIT.RDRF);

  c = SCI.RDR;
  SCI.SSR.BIT.RDRF = 0;
  return c;
}

// RX BUFF CLEAR
void rs_rx_purge (void) {
  while (rs_rx_buff ()) {
    wait (10, true);
    SCI.SSR.BYTE &= ~0x78;
  }
}

static const char hex_code[] = "0123456789ABCDEF";

char *I2H (long v, short len, char *s) {
  short i;

  for (i = 0; i < len; i++) s[i] = '0';
  s[len] = 0;
  do {
    s[--len] = hex_code[v & 0xf];
    v >>= 4;
  } while (len && v);
  return s;
}

char *I2D (long v, short len, char *s) {
  short f = v < 0;
  v = labs(v);

  memset (s, ' ', len);
  s[len] = 0;

  do {
    s[--len] = (v % 10) + '0';
    v /= 10;
  } while (len && v);
  if (f && (len > 0)) s[--len] = '-';
  return s;
}

u32 H2I (char *s) {
  u32 i, n = 0;

  if (!*s) return -1;
  for (i = 0; *s; i++, s++) {
    if ('0' <= *s && *s <= '9') {
      n <<= 4;
      n |= *s - '0';
    } else if ('a' <= *s && *s <= 'f') {
      n <<= 4;
      n |= *s - ('a' - 10);
    } else if ('A' <= *s && *s <= 'F') {
      n <<= 4;
      n |= *s - ('A' - 10);
    }
  }
  return n;
}

int D2I (char *s) {
  int i, n = 0;

  if (!*s) return -1;
  for (i = 0; *s; i++, s++) {
    if ('0' <= *s && *s <= '9') {
      n *= 10;
      n += *s - '0';
    }
  }
  return n;
}

typedef enum {
  mode_str,
  mode_hex,
  mode_dec,
} TCharMode;

char *getstr (char *s, int len, TCharMode m) {
  int i = 0;
  char c;

  while (1) {
    c = rs_getc ();
    if ((c == '\n') || (c == '\r')) {
      s[i++] = '\0';
      break;
    } else if ((i > 0) && (c == '\b')) {
      rs_puts ("\b \b");
      i--;
    } else if ((i < len) && (i >= 0) && (c >= ' ') && (c <= '~')) {
      switch (m) {
        case mode_dec:
          if ((c >= '0') && (c <= '9')) {
            s[i++] = (char)c;
            rs_putc (c);
          }
          break;
        case mode_hex:
          if (((c >= '0') && (c <= '9')) || ((c >= 'a') && (c <= 'f')) || ((c >= 'A') && (c <= 'F'))) {
            s[i++] = c;
            rs_putc (c);
          }
          break;
        default:
         s[i++] = (char)c;
         rs_putc (c);
         break;
      }
    } else rs_putc ('\a');
  }
  return s;
}

/*======================================================================*/
/* WAIT                                                                 */
/*======================================================================*/
bool wait (long num, bool rx) {
  volatile long i;

  CMT.CMSTR.BIT.STR0 = 1;
  for (i = 0; i < num; i++) {
    while (!CMT0.CMCSR.BIT.CMF) {
      if (rx) if (rs_rx_buff()) {
        CMT.CMSTR.BIT.STR0 = 0;
        return true;
      }
    }
    CMT0.CMCSR.BIT.CMF = 0;
  }
  CMT.CMSTR.BIT.STR0 = 0;
  return false;
}

/*======================================================================*/
/* INIT                                                                 */
/*======================================================================*/
void InitSH (void) {
  volatile u8 dum;
  dum = WDT.READ.RSTCSR.BYTE;
  WDT.WRITE.RSTCSR = 0xa500;  // WOVFNA
  WDT.WRITE.RSTCSR = 0x5a1f;  // RSTE,RSTSNA
  dum = WDT.READ.TCSR.BYTE;
  WDT.WRITE.TCSR = 0xa518;  // TCSRNA
  WDT.WRITE.TCSR = 0x5a00;  // TCNTNA

  //--------------------------------------
  // st@NVRg[
  //--------------------------------------
  // |[gARg[WX^H
  PFC.PACRH.BIT.PA23MD  = 1;    // *0:PA23, 1:~WRHH
  PFC.PACRH.BIT.PA22MD  = 1;    // *0:PA22, 1:~WRHL
  PFC.PACRH.BIT.PA21MD  = 0;    // *0:PA21, 1:~CS5
  PFC.PACRH.BIT.PA20MD  = 0;    // *0:PA20, 1:~CS4
  PFC.PACRH.BIT.PA19MD  = 0;    // *0:PA19, 1:~BACK, 2:DRAK1, 3:x
  PFC.PACRH.BIT.PA18MD  = 0;    // *0:PA18, 1:~BREQ, 2:DRAK0, 3:x
  PFC.PACRH.BIT.PA17MD  = 0;    // *0:PA17, 1:~WAIT
  PFC.PACRH.BIT.PA16MD  = 0;    // *0:PA16, 1:x, 2:x, 3:~AUDSYNC
  // |[gARg[WX^L1
  PFC.PACRL1.BIT.PA15MD = 0;    // *0:PA15, 1:CK
  PFC.PACRL1.BIT.PA14MD = 1;    // *0:PA14, 1:~RD
  PFC.PACRL1.BIT.PA13MD = 1;    // *0:PA13, 1:~WRH
  PFC.PACRL1.BIT.PA12MD = 1;    // *0:PA12, 1:~WRL
  PFC.PACRL1.BIT.PA11MD = 1;    // *0:PA11, 1:~CS1
  PFC.PACRL1.BIT.PA10MD = 1;    // *0:PA10, 1:~CS0
  PFC.PACRL1.BIT.PA9MD  = 0;    // *0:PA9, 1:TCLKD, 2:~IRQ3, 3:x
  PFC.PACRL1.BIT.PA8MD  = 0;    // *0:PA8, 1:TCLKC, 2:~IRQ2, 3:x
  // |[gARg[WX^L2
  PFC.PACRL2.BIT.PA7MD  = 0;    // *0:PA7, 1:TCLKB, 2:~CS3, 3:x
  PFC.PACRL2.BIT.PA6MD  = 0;    // *0:PA6, 1:TCLKA, 2:~CS2, 3:x
  PFC.PACRL2.BIT.PA5MD  = 0;    // *0:PA5, 1:SCK1, 2:~DREQ1, 3:~IRQ1
  PFC.PACRL2.BIT.PA4MD  = 1;    // *0:PA4, 1:TXD1
  PFC.PACRL2.BIT.PA3MD  = 1;    // *0:PA3, 1:RXD1
  PFC.PACRL2.BIT.PA2MD  = 0;    // *0:PA2, 1:SCK0, 2:~DREQ0, 3:~IRQ0
  PFC.PACRL2.BIT.PA1MD  = 0;    // *0:PA1, 1:TXD0
  PFC.PACRL2.BIT.PA0MD  = 0;    // *0:PA0, 1:RXD0
  // |[gBRg[WX^1
  PFC.PBCR1.BIT.PB9MD   = 0;    // *0:PB9, 1:~IRQ7, 2:A21, 3:~ADTRG
  PFC.PBCR1.BIT.PB8MD   = 2;    // *0:PB8, 1:~IRQ6, 2;A20, 3:~WAIT
  // |[gBRg[WX^2
  PFC.PBCR2.BIT.PB7MD   = 2;    // *0:PB7, 1:~IRQ5, 2:A19, 3:~BREQ
  PFC.PBCR2.BIT.PB6MD   = 2;    // *0:PB6, 1:~IRQ4, 2:A18, 3:~BACK
  PFC.PBCR2.BIT.PB5MD   = 0;    // *0:PB5, 1:~IRQ3, 2:~POE3, 3:~CS7
  PFC.PBCR2.BIT.PB4MD   = 0;    // *0:PB4, 1:~IRQ2, 2:~POE2, 3:~CS6
  PFC.PBCR1.BIT.PB3MD   = 0;    // *0:PB3, 1:~IRQ1, 2:~POE1, 3:x, 4:SDA0, 5:x, 6:x, 7:x
  PFC.PBCR2.BIT.PB3MD   = 0;
  PFC.PBCR1.BIT.PB2MD   = 0;    // *0:PB2, 1:~IRQ0, 2:~POE0, 3:x, 4:SCL0, 5:x, 6:x, 7:x
  PFC.PBCR2.BIT.PB2MD   = 0;
  PFC.PBCR2.BIT.PB1MD   = 1;    // *0:PB1, 1:A17
  PFC.PBCR2.BIT.PB0MD   = 1;    // *0:PB0, 1:A16
  // |[gCRg[WX^
  PFC.PCCR.BIT.PC15MD   = 1;    // *0:PC15, 1:A15
  PFC.PCCR.BIT.PC14MD   = 1;    // *0:PC14, 1:A14
  PFC.PCCR.BIT.PC13MD   = 1;    // *0:PC13, 1:A13
  PFC.PCCR.BIT.PC12MD   = 1;    // *0:PC12, 1:A12
  PFC.PCCR.BIT.PC11MD   = 1;    // *0:PC11, 1:A11
  PFC.PCCR.BIT.PC10MD   = 1;    // *0:PC10, 1:A10
  PFC.PCCR.BIT.PC9MD    = 1;    // *0:PC9, 1:A9
  PFC.PCCR.BIT.PC8MD    = 1;    // *0:PC8, 1:A8
  PFC.PCCR.BIT.PC7MD    = 1;    // *0:PC7, 1:A7
  PFC.PCCR.BIT.PC6MD    = 1;    // *0:PC6, 1:A6
  PFC.PCCR.BIT.PC5MD    = 1;    // *0:PC5, 1:A5
  PFC.PCCR.BIT.PC4MD    = 1;    // *0:PC4, 1:A4
  PFC.PCCR.BIT.PC3MD    = 1;    // *0:PC3, 1:A3
  PFC.PCCR.BIT.PC2MD    = 1;    // *0:PC2, 1:A2
  PFC.PCCR.BIT.PC1MD    = 1;    // *0:PC1, 1:A1
  PFC.PCCR.BIT.PC0MD    = 1;    // *0:PC0, 1:A0
  // |[gDRg[WX^H1
  PFC.PDCRH1.BIT.PD31MD = 1;    // *0:PD31, 1:D31, 2:~ADTRG, 3:x
  PFC.PDCRH1.BIT.PD30MD = 1;    // *0:PD30, 1:D30, 2:~IRQOUT, 3:x
  PFC.PDCRH1.BIT.PD29MD = 1;    // *0:PD29, 1:D29, 2;~CS3, 3:x
  PFC.PDCRH1.BIT.PD28MD = 1;    // *0:PD28, 1:D28, 2:~CS2, 3:x
  PFC.PDCRH1.BIT.PD27MD = 1;    // *0:PD27, 1:D27, 2:DACK1, 3:x
  PFC.PDCRH1.BIT.PD26MD = 1;    // *0:PD26, 1:D26, 2:DACK0, 3:x
  PFC.PDCRH1.BIT.PD25MD = 1;    // *0:PD25, 1:D25, 2:~DREQ1, 3:x
  PFC.PDCRH1.BIT.PD24MD = 1;    // *0:PD24, 1:D24, 2:~DREQ0, 3:x
  // |[gDRg[WX^H2
  PFC.PDCRH2.BIT.PD23MD = 1;    // *0:PD23, 1:D23, 2:~IRQ7, 3:~AUDSYNC
  PFC.PDCRH2.BIT.PD22MD = 1;    // *0:PD22, 1:D22, 2:~IRQ6, 3:AUDCK
  PFC.PDCRH2.BIT.PD21MD = 1;    // *0:PD21, 1:D21, 2:~IRQ5, 3:AUDMD
  PFC.PDCRH2.BIT.PD20MD = 1;    // *0:PD20, 1:D20, 2:~IRQ4, 3:~AUDRST
  PFC.PDCRH2.BIT.PD19MD = 1;    // *0:PD19, 1:D19, 2:~IRQ3, 3:AUDATA3
  PFC.PDCRH2.BIT.PD18MD = 1;    // *0:PD18, 1:D18, 2:~IRQ2, 3:AUDATA2
  PFC.PDCRH2.BIT.PD17MD = 1;    // *0:PD17, 1:D17, 2:~IRQ1, 3:AUDATA1
  PFC.PDCRH2.BIT.PD16MD = 1;    // *0:PD16, 1:D16, 2:~IRQ0, 3:AUDATA0
  // |[gDRg[WX^L
  PFC.PDCRL2.BIT.PD15MD = 0;    // *0:PD15, 1:D15, 2:x, 3:x
  PFC.PDCRL1.BIT.PD15MD = 1;
  PFC.PDCRL2.BIT.PD14MD = 0;    // *0:PD14, 1:D14, 2:x, 3:x
  PFC.PDCRL1.BIT.PD14MD = 1;
  PFC.PDCRL2.BIT.PD13MD = 0;    // *0:PD13, 1:D13, 2:x, 3:x
  PFC.PDCRL1.BIT.PD13MD = 1;
  PFC.PDCRL2.BIT.PD12MD = 0;    // *0:PD12, 1:D12, 2:x, 3:x
  PFC.PDCRL1.BIT.PD12MD = 1;
  PFC.PDCRL2.BIT.PD11MD = 0;    // *0:PD11, 1:D11, 2:x, 3:x
  PFC.PDCRL1.BIT.PD11MD = 1;
  PFC.PDCRL2.BIT.PD10MD = 0;    // *0:PD10, 1:D10, 2:x, 3:x
  PFC.PDCRL1.BIT.PD10MD = 1;
  PFC.PDCRL2.BIT.PD9MD  = 0;    // *0:PD9, 1:D9, 2:x, 3:x
  PFC.PDCRL1.BIT.PD9MD  = 1;
  PFC.PDCRL2.BIT.PD8MD  = 0;    // *0:PD8, 1:D8, 2:x, 3:x
  PFC.PDCRL1.BIT.PD8MD  = 1;
  PFC.PDCRL2.BIT.PD7MD  = 0;    // *0:PD7, 1:D7, 2:x, 3:x
  PFC.PDCRL1.BIT.PD7MD  = 1;
  PFC.PDCRL2.BIT.PD6MD  = 0;    // *0:PD6, 1:D6, 2:x, 3:x
  PFC.PDCRL1.BIT.PD6MD  = 1;
  PFC.PDCRL2.BIT.PD5MD  = 0;    // *0:PD5, 1:D5, 2:x, 3:x
  PFC.PDCRL1.BIT.PD5MD  = 1;
  PFC.PDCRL2.BIT.PD4MD  = 0;    // *0:PD4, 1:D4, 2:x, 3:x
  PFC.PDCRL1.BIT.PD4MD  = 1;
  PFC.PDCRL2.BIT.PD3MD  = 0;    // *0:PD3, 1:D3, 2:x, 3:x
  PFC.PDCRL1.BIT.PD3MD  = 1;
  PFC.PDCRL2.BIT.PD2MD  = 0;    // *0:PD2, 1:D2, 2:x, 3:x
  PFC.PDCRL1.BIT.PD2MD  = 1;
  PFC.PDCRL2.BIT.PD1MD  = 0;    // *0:PD1, 1:D1, 2:x, 3:x
  PFC.PDCRL1.BIT.PD1MD  = 1;
  PFC.PDCRL2.BIT.PD0MD  = 0;    // *0:PD0, 1:D0, 2:x, 3:x
  PFC.PDCRL1.BIT.PD0MD  = 1;
  // |[gERg[WX^1
  PFC.PECRL1.BIT.PE15MD = 0;    // *0:PE15, 1:TIOC4D, 2,DACK1, 3:~IRQOUT
  PFC.PECRL1.BIT.PE14MD = 0;    // *0:PE14, 1:TIOC4C, 2,DACK0, 3:x
  PFC.PECRL1.BIT.PE13MD = 0;    // *0:PE13, 1:TIOC4B, 2,~MRES, 3:x
  PFC.PECRL1.BIT.PE12MD = 0;    // *0:PE12, 1:TIOC4A, 2:x, 3:TXD3
  PFC.PECRL1.BIT.PE11MD = 0;    // *0:PE11, 1:TIOC3D, 2:x, 3:RXD3
  PFC.PECRL1.BIT.PE10MD = 0;    // *0:PE10, 1:TIOC3C, 2:TXD2, 3:x
  PFC.PECRL1.BIT.PE9MD  = 0;    // *0:PE9, 1:TIOC3B, 2,x, 3:SCK3
  PFC.PECRL1.BIT.PE8MD  = 0;    // *0:PE8, 1:TIOC3A, 2,SCK2, 3:x
  // |[gERg[WX^2
  PFC.PECRL2.BIT.PE7MD  = 0;    // *0:PE7, 1:TIOC2B, 2:RXD2, 3:x
  PFC.PECRL2.BIT.PE6MD  = 0;    // *0:PE6, 1:TIOC2A, 2:SCK3, 3:AUDATA0
  PFC.PECRL2.BIT.PE5MD  = 0;    // *0:PE5, 1:TIOC1B, 2:TXD3, 3:AUDATA1
  PFC.PECRL2.BIT.PE4MD  = 0;    // *0:PE4, 1:TIOC1A, 2:RXD3, 3:AUDATA2
  PFC.PECRL2.BIT.PE3MD  = 0;    // *0:PE3, 1:TIOC0D, 2:DRAK1, 3:AUDATA3
  PFC.PECRL2.BIT.PE2MD  = 0;    // *0:PE2, 1:TIOC0C, 2:~DREQ1, 3:~AUDRST
  PFC.PECRL2.BIT.PE1MD  = 0;    // *0:PE1, 1:TIOC0B, 2:DRAK0, 3:AUDMD
  PFC.PECRL2.BIT.PE0MD  = 0;    // *0:PE0, 1:TIOC0A, 2:~DREQ0, 3:AUDCK

  // |[gI/OWX^
  PFC.PAIORH.WORD = 0x0000;     // PA *0:IN, 1:OUT
  PFC.PAIORL.WORD = 0x0000;     // PA *0:IN, 1:OUT
  PFC.PBIOR.WORD  = 0x0000;     // PB *0:IN, 1:OUT
  PFC.PCIOR.WORD  = 0x0000;     // PC *0:IN, 1:OUT
  PFC.PDIORH.WORD = 0x0000;     // PD *0:IN, 1:OUT
  PFC.PDIORL.WORD = 0x0000;     // PD *0:IN, 1:OUT
  PFC.PEIORL.WORD = 0x0000;     // PE *0:IN, 1:OUT

  //--------------------------------------
  // oXXe[gRg[
  //--------------------------------------
  // 1MoCggS-RAM32rbgoXɂĐڑ܂B
  // ̑̃s͑SSH̃ZbgԂƓɂĂ܂B

  // oXRg[WX^1
  BSC.BCR1.BIT.MTURWE   = 1;    // MTUWX^ANZX 0:֎~, *1:
  BSC.BCR1.BIT.A3LG     = 0;    // *0:~CS3 A3SZQ, 1:~CS3 32bit
  BSC.BCR1.BIT.A2LG     = 0;    // *0:~CS2 A2SZQ, 1:~CS2 32bit
  BSC.BCR1.BIT.A1LG     = 1;    // *0:~CS1 A1SZQ, 1:~CS1 32bit
  BSC.BCR1.BIT.A0LG     = 0;    // *0:~CS0 A0SZQ, 1:~CS0 32bit
  BSC.BCR1.BIT.A3SZ     = 1;    // 0:~CS3 8bit, *1:~CS3 16bit
  BSC.BCR1.BIT.A2SZ     = 1;    // 0:~CS2 8bit, *1:~CS2 16bit
  BSC.BCR1.BIT.A1SZ     = 1;    // 0:~CS1 8bit, *1:~CS1 16bit
  BSC.BCR1.BIT.A0SZ     = 1;    // 0:~CS0 8bit, *1:~CS0 16bit

  // oXRg[WX^2
  BSC.BCR2.BIT.IW3      = 3;    // ~CS3ANZXAChTCN 0`*3
  BSC.BCR2.BIT.IW2      = 3;    // ~CS2ANZXAChTCN 0`*3
  BSC.BCR2.BIT.IW1      = 0;    // ~CS1ANZXAChTCN 0`*3
  BSC.BCR2.BIT.IW0      = 0;    // ~CS0ANZXAChTCN 0`*3
  BSC.BCR2.BIT.CW3      = 1;    // ~CS3AANZXAChTCN 0`*1
  BSC.BCR2.BIT.CW2      = 1;    // ~CS2AANZXAChTCN 0`*1
  BSC.BCR2.BIT.CW1      = 0;    // ~CS1AANZXAChTCN 0`*1
  BSC.BCR2.BIT.CW0      = 0;    // ~CS0AANZXAChTCN 0`*1
  BSC.BCR2.BIT.SW3      = 1;    // ~CS3AT[gg 0:Ȃ, *1:
  BSC.BCR2.BIT.SW2      = 1;    // ~CS2AT[gg 0:Ȃ, *1:
  BSC.BCR2.BIT.SW1      = 0;    // ~CS1AT[gg 0:Ȃ, *1:
  BSC.BCR2.BIT.SW0      = 0;    // ~CS0AT[gg 0:Ȃ, *1:

  // EFCgRg[WX^1
  BSC.WCR1.BIT.W3       = 15;   // ~CS3ANZXEFCg 0`*15
  BSC.WCR1.BIT.W2       = 15;   // ~CS2ANZXEFCg 0`*15
  BSC.WCR1.BIT.W1       = 0;    // ~CS1ANZXEFCg 0`*15
  BSC.WCR1.BIT.W0       = 4;    // ~CS0ANZXEFCg 0`*15

  //-------------------------------------------
  // W[X^oCWX^ݒ
  //-------------------------------------------
  MST.CR1.BIT._SCI1 = 0;
  MST.CR2.BIT._CMT  = 0;

  //-------------------------------------------
  // EFCgp^C}
  //-------------------------------------------
  CMT0.CMCSR.BIT.CMIE   = 0;
  CMT0.CMCSR.BIT.CKS    = 1;
  CMT0.CMCSR.BIT.CMF    = 0;
  CMT0.CMCNT            = 0;
  CMT0.CMCOR            = 921 - 1;  // 1ms

  SCI.SCR.BYTE = SCI.SMR.BYTE = 0;
  SCI.BRR = br57600;           // {[[gݒ
  wait (50, false);
  SCI.SCR.BYTE = 0x30;         // M
  SCI.SSR.BYTE;                // _~[[h
  SCI.SSR.BYTE = 0x80;         // G[tONA
}

void InitialSH (void) {
  // OoXȊOZbg̏Ԃɖ߂
  CMT.CMSTR.WORD = 0;
  CMT0.CMCSR.WORD = 0;
  CMT0.CMCNT = 0;
  CMT0.CMCOR = 0;

  SCI.SCR.BYTE = 0;
  SCI.BRR = 0;
  SCI.SMR.BYTE = 0;
  SCI.SSR.BYTE = 0;

  PFC.PACRL2.WORD       = 0;

  MST.CR1.WORD = 0xf03f;
  MST.CR2.WORD = 0xf0fd;
}

/*======================================================================*/
/* XMODEM                                                               */
/*======================================================================*/
/*-----XMODEM̃pPbg-------*
  M              M
         --- NAK -->
         <-- SOH --- (128bytẽubNJn)
         <--  01 --- (ubNԍ)
         <--  FE --- (ubNԍ𔽓])
         <--  .. --- (ۂ̃f[^ 128 bytes)
              ..
         <-- sum --- (checksum)

         --- ACK -->
 *--------------------------------*/
/*-----XMODEM1k̃pPbg-------*
  M              M
         --- 'C' -->
         <-- STX --- (1024bytẽubNJn)
         <--  01 --- (ubNԍ)
         <--  FE --- (ubNԍ𔽓])
         <--  .. --- (ۂ̃f[^ 1024 bytes)
              ..
         <-- sumH --- (CRC)
         <-- sumL --- (CRC)

         --- ACK -->
 *--------------------------------*/
#define _CNTOVER  (5)

void mcpy (u8 *d, u8 *s, int len) {
  int i;

  for (i = 0; i < len; i++) *d++ = *s++;
}

u32 XmodemRX (void) {

  bool my_put_ack (void) {
    char i = 0;
    for (i = 0; i < _CNTOVER; i++) {
      rs_putc (_ACK);  // OK
      if (wait (100, true)) return true;
    }
    return false;
  }

  bool my_get_char (u8 *ch, bool f) {
    int cntover = 0;

    if (wait (50, true)) {
      *ch = (u8)rs_getc ();
      return true;
    } else {
      if (f) {
        wait (100, false);
        rs_rx_purge ();
        do {
          rs_putc (_NAK);
          wait (100, true);
          if (cntover++ > _CNTOVER) break;
        } while (!rs_rx_buff ());
      }
      return false;
    }
  }

  u8 xbuff[2048], head, sum0 = 0, sum1, h0 = 1, h1, h2;
  u16 sum2;
  int  i = 0;
  u32  size = 0, adr = 0, fladdr = RAM_ADDRESS;
  bool f;

  while (!rs_rx_buff ()) {
#if _XMODEM_PACKET_SIZE == 128
    rs_putc (_NAK);
#else
    rs_putc (_XYC);
#endif
    if (wait (100, true)) break;
    if (i++ > 240) return 0;
  }
  for (;;) {
    if (my_get_char (&head, true)) {
      switch (head) {
#if _XMODEM_PACKET_SIZE == 128
        case _SOH:
#else
        case _STX:
#endif
          if (my_get_char (&h1, false)) {
            if (my_get_char (&h2, false)) {
              if (h1 != ((~h2) & 0xff)) {
                wait (50, false);
                rs_rx_purge ();
                rs_putc (_NAK);
              } else {
                if (h1 == h0) {
                  sum2 = 0;
                  f = false;
                  for (i = 0; i < _XMODEM_PACKET_SIZE; i++) {
                    if ((f = my_get_char (&xbuff[adr + i], false))) {
#if _XMODEM_PACKET_SIZE == 128
                      sum2 = (sum2 + xbuff[adr + i]) & 0xff;
#else
                      sum2 = sum2 ^ xbuff[adr + i] << 8;
                      int  j;
                      for (j = 0; j < 8; ++j) {
                        if (sum2 & 0x8000) sum2 = sum2 << 1 ^ 0x1021;
                        else               sum2 = sum2 << 1;
                      }
#endif
                    } else break;
                  }
                  if (f) {
#if _XMODEM_PACKET_SIZE == 128
                    if (my_get_char (&sum1, false))
#else
                    if (my_get_char (&sum0, false) && my_get_char (&sum1, false))
#endif
                    {
                      if (((sum0 << 8) | sum1) == sum2) {
                        adr += _XMODEM_PACKET_SIZE;
                        h0++;
                        if ((adr % sizeof (xbuff)) == 0) {
                          mcpy ((void *)fladdr, (void *)xbuff, sizeof (xbuff));
                          fladdr += sizeof (xbuff);
                          adr = 0;
                        }
                        size += _XMODEM_PACKET_SIZE;
                        if (!my_put_ack ()) { // OK
                          rs_putc (_CAN);
                          wait (200, false);
                          rs_rx_purge ();
                          return 0;
                          break;
                        }
                      } else {
                        wait (50, false);
                        rs_rx_purge ();
                        rs_putc (_NAK);
                      }
                    }
                  } else {
                    wait (50, false);
                    rs_rx_purge ();
                    rs_putc (_NAK);
                  }
                }
              }
            }
          }
          break;
        case _EOT:
          if (adr) {
            mcpy ((void *)fladdr, (void *)xbuff, adr);
          }
          rs_rx_purge ();
          rs_putc (_ACK);
          wait (200, false);
          return size + adr;
          break;
        case _CAN:
          wait (200, false);
          rs_rx_purge ();
          return 0;
          break;
        default:
          wait (50, false);
          rs_rx_purge ();
          rs_putc (_NAK);
          break;
      }
    }
  }
}

int getc2 (int w) {
  wait (w, true);
  if (rs_rx_buff ()) return rs_getc ();
  return -1;
}

int XmodemTX (u8 *src, int srcsz) {
  u16 sum2;
  u8  xbuff[1030], packetno = 1;
  int packetsize = 0, i, j, c, len = 0, retry = 0;
  bool crc = false;

  while (!rs_rx_buff ()) {
    if (wait (100, true)) {
      switch (c = rs_getc ()) {
        case _XYC:  // 1kbyte
          crc = true;
          packetsize = 1024;
          break;
        case _NAK:  // 128byte
          crc = false;
          packetsize = 128;
          break;
        case _CAN:  // canceled by remote
          wait (50, false);
          rs_rx_purge ();
          rs_putc (_ACK);
          return -1;
          break;
        default:    // cancel
          wait (50, false);
          rs_rx_purge ();
          rs_putc (_CAN);
          return -1;
          break;
      }
      break;
    }
    if (retry++ > _CNTOVER * 10) return -1;
  }

  for (;;) {
    xbuff[0] = crc ? _STX : _SOH;
    xbuff[1] = packetno;
    xbuff[2] = ~packetno;
    if ((c = srcsz - len) > packetsize) c = packetsize;
    if (c >= 0) {
      memset (&xbuff[3], 0xff, packetsize);
      sum2 = 0;
      for (i = 0; i < packetsize; i++) {
        xbuff[3 + i] = src[len + i];
        if (crc) {
          sum2 = sum2 ^ xbuff[3 + i] << 8;
          for (j = 0; j < 8; ++j) {
            if (sum2 & 0x8000) sum2 = sum2 << 1 ^ 0x1021;
            else               sum2 = sum2 << 1;
          }
        } else sum2 = (sum2 + xbuff[3 + i]) & 0xff;
      }
      if (crc) {
        xbuff[packetsize + 3] = (sum2 >> 8) & 0xFF;
        xbuff[packetsize + 4] = sum2 & 0xFF;
      } else xbuff[packetsize + 3] = sum2;
      for (retry = 0; retry < _CNTOVER; ++retry) {
        for (i = 0; i < packetsize + 4 + (crc ? 1 : 0); i++) rs_putc (xbuff[i]);
        if ((c = getc2 (200)) >= 0) {
          switch (c) {
            case _ACK:  // ok
              packetno++;
              len += packetsize;
              retry = _CNTOVER;
              break;
            case _CAN:  // canceled by remote
              wait (50, false);
              rs_rx_purge ();
              rs_putc (_ACK);
              return -1;
              break;
            case _NAK:  // retry
            default:
              wait (50, false);
              rs_rx_purge ();
              break;
          }
        }
      }
      if (c != _ACK) {
        wait (50, false);
        rs_rx_purge ();
        rs_putc (_CAN);
        return -1;
      }
    } else {
      for (retry = 0; retry < _CNTOVER; retry++) {
        rs_putc (_EOT);
        if ((c = getc2 (500)) == _ACK) break;
      }
      rs_rx_purge ();
      return (c == _ACK) ? len : -5;
    }
  }
}

/*======================================================================*/
/* FLASH CTRL                                                           */
/*======================================================================*/
volatile u16 *FL = (u16 *)FLASH_ADDRESS;
volatile u16 *RA = (u16 *)RAM_ADDRESS;
#define EXFLASH(addr)  *((volatile u16 *)(FLASH_ADDRESS | ((addr) << 1)))
#define EXFLASH_RESET  EXFLASH(0) = 0xf0;

void ExtFlash_BlockWrite (u32 offset, volatile u16 *data, u32 size) {
  u32 i, s2 = size / 40;
  volatile u16 *adr = (u16 *)(FLASH_ADDRESS + offset);

  EXFLASH_RESET;

  EXFLASH(0x555) = 0xaa;
  EXFLASH(0x2AA) = 0x55;
  EXFLASH(0x555) = 0x20;
  for (i = 0; i < size; i++) {
    EXFLASH(0) = 0xa0;
    *adr = *data;
    while (*adr != *data) ;
    adr++;  data++;
    if (i % s2 == 0) rs_putc('.');
  }
  EXFLASH(0) = 0x90;

  EXFLASH_RESET;
}

void ExtFlash_WordWrite (u32 offset, u16 data) {
  u16 *adr = (u16 *)(FLASH_ADDRESS + offset);

  EXFLASH_RESET;

  EXFLASH(0x555) = 0xaa;
  EXFLASH(0x2AA) = 0x55;
  EXFLASH(0x555) = 0xa0;

  *adr = data;
  while (*adr != data) ;
}

bool ExtFalsh_RamCheck (u32 offset, volatile u16 *data, u32 size) {
  u32 i, s2 = size / 40;
  volatile u16 *adr = (u16 *)(FLASH_ADDRESS + offset);

  for (i = 0; i < size; i++) {
    if (!(*adr == *data)) return false;
    adr++;  data++;
    if (i % s2 == 0) rs_putc ('.');
  }
  return true;
}

bool ExtFlash_Signature (void) {
  u32 d;

  EXFLASH_RESET;

  EXFLASH(0x555) = 0xaa;
  EXFLASH(0x2AA) = 0x55;
  EXFLASH(0x555) = 0x90;
  d = ((EXFLASH(0) & 0xff) << 16) | EXFLASH(1);

  EXFLASH_RESET;

  return (d == FLASH_SIG1) || (d == FLASH_SIG2);
}

void ExtFlash_SectionErase (u32 sz) {
  u32 i;
  u16 d;

  EXFLASH_RESET;

  for (i = 0; i <= ((sz & 0xff0000) >> 16); i++) {
    EXFLASH(0x555) = 0xaa;
    EXFLASH(0x2AA) = 0x55;
    EXFLASH(0x555) = 0x80;
    EXFLASH(0x555) = 0xaa;
    EXFLASH(0x2AA) = 0x55;
    *((volatile u16 *)(FLASH_ADDRESS | (FLASH_ADDRESS + (i << 16)))) = 0x30;

    while (1) {
      d = *((volatile u16 *)FLASH_ADDRESS);
      if (d == 0xffff) break;
      wait (200, false);
      rs_putc ('0' + (i % 10));
    }

    EXFLASH_RESET;
  }
}

void ExtFlash_EraseAll (void) {
  int i = 0;
  EXFLASH_RESET;

  EXFLASH(0x555) = 0xaa;
  EXFLASH(0x2AA) = 0x55;
  EXFLASH(0x555) = 0x80;
  EXFLASH(0x555) = 0xaa;
  EXFLASH(0x2AA) = 0x55;
  EXFLASH(0x555) = 0x10;

  while (1) {
    if (EXFLASH(0) == 0xffff) break;
    if ((i++ % 200000) == 0) rs_putc('.');
  }

  EXFLASH_RESET;
}

void ExtFlash_DeviceInfo (void) {
  int i;
  char s[10];

  EXFLASH_RESET;

  EXFLASH(0x555) = 0xaa;
  EXFLASH(0x2AA) = 0x55;
  EXFLASH(0x555) = 0x90;

  rs_puts ("\n Manufactur ID:$"); rs_puts (I2H (EXFLASH(0), 2, s));
  rs_puts ("\n Device ID:$"); rs_puts (I2H (EXFLASH(1), 4, s));
  rs_puts ("\n Sector Protect SA[30..0]:$b");
  for (i = 30; i >= 0; i--) {
    rs_putc(EXFLASH((i << 16) + 2) ? '1' : '0');
  }
  EXFLASH_RESET;
  rs_puts ("\n Execute Status:");
  if (*((u32 *)FLASH_ADDRESS) != 0xFFFFFFFFU) rs_puts ("Programmed"); else rs_puts ("Empty");
}

/*======================================================================*/
/* MAIN                                                                 */
/*======================================================================*/
typedef void (*fp)(void) ;

bool UPG (bool mess) {
  u32 *FWBOOT = (u32 *)FLASH_ADDRESS;
  u32 *RAMBOOT = (u32 *)RAM_ADDRESS;
  bool exflash_ok = ((*FWBOOT != 0xFFFFFFFFU) && ExtFlash_Signature ());
  bool exram_ok = ((*RAMBOOT > RAM_ADDRESS) && (*RAMBOOT < RAM_ADDRESS + RAM_BYTE_SIZE));
  void (*UserProgram)(void);

  if (exflash_ok) {
    if ((*FWBOOT > RAM_ADDRESS) && (*FWBOOT < (RAM_ADDRESS + RAM_BYTE_SIZE))) {
      if (mess) rs_puts("\nCPY ExFLASH TO ExRAM & EXEC FROM ExRAM\n");
      mcpy ((void *)RAM_ADDRESS, (void *)FLASH_ADDRESS, RAM_BYTE_SIZE);
      UserProgram = (fp)*RAMBOOT;
    } else {
      if (mess) rs_puts("\nEXEC FROM ExFLASH\n");
      UserProgram = (fp)*FWBOOT;
    }
  } else if (exram_ok) {
    if (mess) rs_puts("\nEXEC FROM ExRAM\n");
    UserProgram = (fp)*RAMBOOT;
  } else return false;
  wait (100, false);
  InitialSH ();
  UserProgram ();
  return true;
}

void main (void) {
  char  ch = 0;
  u32 i, j;
  char s[10];
  bool sres = (WDT.READ.RSTCSR.BYTE & 0x80);

  void purge (void) {
    do {
      rs_rx_purge ();
      wait (50, true);
    } while (rs_rx_buff ());
  }

  bool AreYouSure (const char *s) {
    char c;
    rs_puts ((char *)s);
    rs_puts ((char *)mess[11]);
    rs_putc (c = rs_getc ());
    return (c == 'y' || c == 'Y');
  }

  void ClearRAM (void) {
    int i;
    u32 *POS = (u32 *)RAM_ADDRESS;
    for (i = 0; i < RAM_LONG_SIZE; i++) POS[i] = 0xffffffff;
  }

  InitSH ();

  if (!sres) {
    while (1) {
      if (getc2 (100) == '!')
        if (getc2 (100) == '!')
          if (getc2 (100) == '!') break;
      if (--ch <= 0) {
        wait (20, false);
        rs_rx_purge ();
        if (!UPG (false)) {
          rs_puts ((char *)mess[14]);
          break;
        }
      }
    }
  } else
    rs_puts ((pchar)mess[17]);

  rs_puts ((pchar)mess[0]);
  purge ();

  for (;;) {
    rs_rx_purge ();
    rs_puts ("\n>");
    rs_putc (ch = tolower(rs_getc ()));
    switch (tolower (ch)) {
      case 'e':
        if (AreYouSure (mess[12]) && ExtFlash_Signature ()) {
          ExtFlash_EraseAll ();
          rs_puts ((char *)mess[10]);
        } else
          rs_puts ((char *)mess[9]);
        break;
      case 'c':
        if (AreYouSure (mess[13]) && ExtFlash_Signature ()) {
          ClearRAM ();
          rs_puts ((char *)mess[10]);
        } else
          rs_puts ((char *)mess[9]);
        break;
      case 'w':
        if (AreYouSure (mess[4])) rs_puts ((char *)mess[XmodemRX () ? 7 : 8]);
        else rs_puts ((char *)mess[9]);
        break;
      case 'f':
        if (ExtFlash_Signature ()) {
          if (AreYouSure (mess[5]))  {
            rs_puts ((char *)mess[(i = XmodemRX ()) ? 7 : 8]);
            if (i != 0) {
              rs_puts ("\n ERASE ExFLASH ");
              ExtFlash_SectionErase (i);
              rs_puts ("\n FLASH WRITE ");
              ExtFlash_BlockWrite (0, RA, i >> 1);
              rs_puts ("\n VERIFY CHECK ");
              rs_puts((pchar)mess[ExtFalsh_RamCheck (0, RA, i >> 1) ? 7 : 8]);
            }
          } else rs_puts ((char *)mess[9]);
        } else rs_puts((pchar)mess[8]);
        break;
      case 'r':
        rs_puts ((char *)mess[15]);
        if ((i = H2I (getstr (s, 8, mode_hex))) == 0xFFFFFFFFU) i = RAM_ADDRESS;
        rs_repeatchar ('\b', strlen(s)); rs_puts (I2H (i, 8, s));
        rs_puts ((char *)mess[16]);
        if ((j = H2I (getstr (s, 8, mode_hex))) == 0xFFFFFFFFU) j = RAM_BYTE_SIZE;
        rs_repeatchar ('\b', strlen(s)); rs_puts (I2H (j, 8, s));
        rs_puts ((char *)mess[6]);
        if (AreYouSure ("")) rs_puts ((char *)mess[XmodemTX ((u8 *)i, j) ? 7 : 8]);
        else rs_puts ((char *)mess[9]);
        break;
      case 'g':
        if (!UPG (true)) rs_puts ((char *)mess[14]);
        break;
      case 'i':
        ExtFlash_DeviceInfo();
        break;
      case 'x':
        WDT.WRITE.RSTCSR = 0x5a40;//0b 0100 0000;  // RSTE(6):1
        WDT.WRITE.TCSR = 0xa560;
        break;
      default:
        rs_puts ((pchar)mess[0]);
        rs_puts ((pchar)mess[1]);
        break;
    }
  }
}
